{-# LANGUAGE FlexibleContexts #-}
module Data.Functor.Representable (set, get, adjust) where
import Data.Functor.Rep (Representable(index, Rep, tabulate))

get :: Representable f => f a -> Rep f -> a
get = index

set :: (Representable f, Eq (Rep f)) => Rep f -> a -> f a -> f a
set i x old = tabulate override
  where
    override j
      | i == j    = x
      | otherwise = index old j

adjust :: (Representable f, Eq (Rep f)) => Rep f -> (a -> a) -> f a -> f a
adjust i f old = tabulate override
  where
    override j
      | i == j = f (index old j)
      | otherwise = index old j

