module Sudoku.Field (Field(..), parse, toDigit, maybeToDigit) where
import qualified Text.Megaparsec.Char as MegaParsec
import Text.Megaparsec (Parsec)
import Data.Void (Void)
import Data.Text (Text)
import qualified Data.Char as Char

data Field
  = One
  | Two
  | Three
  | Four
  | Five
  | Six
  | Seven
  | Eight
  | Nine
  deriving (Show, Ord, Eq, Enum, Bounded)

parse :: Parsec Void Text (Maybe Field)
parse = do
  c <- MegaParsec.digitChar
  pure $ case c of
    '0' -> Nothing
    _  -> Just $ toEnum (Char.digitToInt c - 1)

toDigit :: Field -> Char
toDigit = Char.intToDigit . (+1) . fromEnum

maybeToDigit :: Maybe Field -> Char
maybeToDigit = maybe '_' toDigit
